#if defined(HAVE_CONFIG_H)
#include "../hdrfiles/config.h"
#endif

#include "../hdrfiles/includes.h"

/*--------------------------------------------------------*/
/* Talker-related include files                           */ 
/*--------------------------------------------------------*/
#include "../hdrfiles/osdefs.h"
/*
#include "../hdrfiles/authuser.h"
#include "../hdrfiles/text.h"
*/
#include "../hdrfiles/constants.h"
#include "../hdrfiles/protos.h"

extern char mess[ARR_SIZE+25];    /* functions use mess to send output   */
extern char t_mess[ARR_SIZE+25];  /* functions use t_mess as a buffer    */
extern int NUM_AREAS;          /* number of areas defined in config file */
extern char thishost[101];      /* FQDN were running on                   */
extern int noprompt;            /* talker waiting for user input?         */
extern int PORT;                  /* main login port for incoming   */


/*------------------------------------------*/
/* Remove all files from the junk directory */
/*------------------------------------------*/
void remove_junk(int startup)
{
char small_buff[64];
char filerid[FILE_NAME_LEN];
char filename[FILE_NAME_LEN];
struct dirent *dp;
DIR  *dirp;
 
 strcpy(t_mess,"junk");
 strncpy(filerid,t_mess,FILE_NAME_LEN);

 dirp=opendir((char *)filerid);

 if (dirp == NULL)
   {
    sprintf(t_mess,"RJUNK: Can't open directory \"%s\" for remove_junk! %s\n",filerid,get_error());
    write_log(ERRLOG,YESTIME,t_mess);

	if (startup)
	printf("%s",t_mess);
    return;
   }
   
 while ((dp = readdir(dirp)) != NULL) 
   { 
    sprintf(small_buff,"%s",dp->d_name);
       if (small_buff[0] != '.')
        {
         sprintf(filename,"%s/%s",filerid,small_buff);
         remove(filename);
        }
    filename[0]=0;
    small_buff[0]=0;
   }

 (void) closedir(dirp);
}


/* Convert userdata file from old version to new version */
/* mode 0 - convert already standardized file		 */
/* mode 1 - convert old non-standardized file		 */
int convert_file(FILE *f, char *filename, int mode)
{
char junk[20];
char buf[1001];
char tempfile[FILE_NAME_LEN];
FILE *rfp;
FILE *wfp;

fclose(f);
if (!(rfp=fopen(filename,"r"))) {
        write_log(ERRLOG,YESTIME,"CONVERT: Couldn't open userfile(r) \"%s\" in convert_file! %s\n",filename,get_error());
	return 0;
	}
strcpy(tempfile,get_temp_file());
if (!(wfp=fopen(tempfile,"w"))) {
        write_log(ERRLOG,YESTIME,"CONVERT: Couldn't open tempfile(w) \"%s\" to be used in convert_file! %s\n",tempfile,get_error());
	return 0;
	}

if (mode==0) {
	/* first line is version, discard */
	rbuf(junk,20);
	/* write current version to file */
	fputs(UDATA_VERSION,wfp);
	fputs("\n",wfp);

	while (fgets((char *)buf,1000,rfp) != NULL) {
	buf[strlen(buf)-1]=0; /* get rid of nl */

	if (!strncmp(buf,"--ENDVER",8)) {
		/* any new structs I have should get written here */
		remove_first(buf);
		if (!strcmp(buf,"121.ver")) {
		fputs("0\n",wfp); /* hangman wins */
		fputs("0\n",wfp); /* hangman losses */
		fputs("No idea\n",wfp); /* ICQ number */
		fputs("NA\n",wfp); /* miscstr1 */
		fputs("NA\n",wfp); /* miscstr2 */
		fputs("NA\n",wfp); /* miscstr3 */
		fputs("NA\n",wfp); /* miscstr4 */
		fputs("1 0 0 0 0\n",wfp); /* pause_login, miscnum2-5 */
		}
		/* tack on new marker for this version */
		sprintf(mess,"--ENDVER %s\n",UDATA_VERSION);
		fputs(mess,wfp);
		/* continue on looking for user-added structs */
	  } /* end of if ENDVER */
	else {
		fputs(buf,wfp);
		fputs("\n",wfp);
	  } /* end of else */

	} /* end of while */
	fclose(rfp);
	fclose(wfp);
	remove(filename);
	rename(tempfile,filename);
  } /* end of if mode 0 */
else if (mode==1) {
	fputs(UDATA_VERSION,wfp);
	fputs("\n",wfp);

	while (fgets((char *)buf,1000,rfp) != NULL) {
	buf[strlen(buf)-1]=0; /* get rid of nl */

	if (!strcmp(buf,"..End revokes..")) {
		fputs(buf,wfp);
		fputs("\n",wfp);
		/* any new structs I have should get written here */
		fputs("0\n",wfp); /* hangman wins */
		fputs("0\n",wfp); /* hangman losses */
		fputs("No idea\n",wfp); /* ICQ number */
		fputs("NA\n",wfp); /* miscstr1 */
		fputs("NA\n",wfp); /* miscstr2 */
		fputs("NA\n",wfp); /* miscstr3 */
		fputs("NA\n",wfp); /* miscstr4 */
		fputs("1 0 0 0 0\n",wfp); /* pause_login, miscnum2-5 */
		/* tack on marker */
		sprintf(mess,"--ENDVER %s\n",UDATA_VERSION);
		fputs(mess,wfp);
		/* continue on looking for user-added structs */
	  } /* end of if revoke */
	else {
		fputs(buf,wfp);
		fputs("\n",wfp);
	  } /* end of else */

	} /* end of while */
	fclose(rfp);
	fclose(wfp);
	remove(filename);
	rename(tempfile,filename);
  } /* end of else if mode if 1 */

return 1;
}


/*** count no. of messages (counts no. of newlines in message files) ***/
void messcount()
{
char filename[FILE_NAME_LEN];
int a;

for(a=0;a<NUM_AREAS;++a) {
	astr[a].mess_num=0;
	sprintf(t_mess,"%s/board%d",MESSDIR,a);
	strncpy(filename,t_mess,FILE_NAME_LEN);
	
        astr[a].mess_num = file_count_lines(filename);
	}
}


/** page a file out to a socket **/
int cat_to_sock(char *filename, int accept_sock)
{
int n;
int count=0;
char line[257];
FILE *fp;

if (!(fp=fopen(filename,"rb"))) 
  {
   write_log(ERRLOG,YESTIME,"Can't open binary file(rb) \"%s\" in cat_to_sock! %s\n",filename,get_error());
   return 0;
  }

line[0]=0;

/*
fread(line, 1, 257, fp);

while(!feof(fp)) {
	        S_WRITE(accept_sock,line,strlen(line));

  fread(line, 1, 256, fp);
*/

while ((n = fread(line, 1, sizeof line,  fp)) != 0) {
   count+=S_WRITE(accept_sock,line,n);

   } /* end of feof */

fclose(fp);

return 1;
}


/** page a file out to a socket **/
int cat_to_www(char *filename, int user)
{
int n=0;
char line[257];
FILE *fp;

if (!(fp=fopen(filename,"rb"))) 
  {
   write_log(ERRLOG,YESTIME,"Can't open binary file(rb) \"%s\" in cat_to_www! %s\n",filename,get_error());
   return 0;
  }

line[0]=0;

while ((n = fread(line, 1, 256, fp)) != 0) {
   write_str_www(user,line,n);
   line[0]=0;
   } /* end of feof */
fclose(fp);

return 1;
}


/*** page a file out to user ***/
int cat(char *filename, int user, int line_num)
{
int num_chars=0,lines=0,retval=1;
FILE *fp;
int max_lines = 25;
int line_pos = 0;
int i = 0;
char leader[17];

if (!(fp=fopen(filename,"r"))) 
  {
   ustr[user].file_posn  = 0;  
   ustr[user].line_count = 0;
   return 0;
  }

if (line_num == 1)
  ustr[user].number_lines = 1;

  
/* jump to reading posn in file */
if (line_num != -1) 
  {
    fseek(fp,ustr[user].file_posn,0);
    max_lines = ustr[user].rows;
    line_pos = ustr[user].line_count;
  }
 else
  {
    max_lines = 999;
    line_num = 0;
  }
  
if (max_lines < 5 || max_lines > 999)
   max_lines = 25;

/* loop until end of file or end of page reached */
mess[0]=0;
fgets(mess, sizeof(mess)-25, fp);
		   strcpy(mess,check_var(mess,SYS_VAR,SYSTEM_NAME));
		   strcpy(mess,check_var(mess,USER_VAR,ustr[user].say_name));
		   strcpy(mess,check_var(mess,HOST_VAR,thishost));
		   strcpy(mess,check_var(mess,MAINPORT_VAR,itoa(PORT)));

if (!ustr[user].cols) ustr[user].cols=80;

while(!feof(fp) && lines < max_lines) 
  {
   line_pos++;
  
   i = strlen(mess);
   lines      += i / ustr[user].cols + 1;
   num_chars  += i;
   
   if (ustr[user].number_lines) {
    if (ustr[user].numbering > 0)
     sprintf(leader,"%-3d ",ustr[user].numbering);
    else
     sprintf(leader,"%-3d ",line_pos);
    }
    else {
          leader[0]=0;
         }

   mess[i-1] = 0;      /* remove linefeed */
   sprintf(t_mess,"%s%s",leader, mess);
    
   write_str(user,t_mess);
   if (ustr[user].numbering > 0) ustr[user].numbering++;
   fgets(mess, sizeof(mess)-25, fp);
		   strcpy(mess,check_var(mess,SYS_VAR,SYSTEM_NAME));
		   strcpy(mess,check_var(mess,USER_VAR,ustr[user].say_name));
		   strcpy(mess,check_var(mess,HOST_VAR,thishost));
		   strcpy(mess,check_var(mess,MAINPORT_VAR,itoa(PORT)));
  }
  
if (user== -1) goto SKIP;

if (feof(fp)) 
  {
   ustr[user].number_lines = 0;
   ustr[user].file_posn    = 0;  
   ustr[user].line_count   = 0;
   ustr[user].numbering    = 0;
   noprompt=0;  
   retval=2;
  }
else  
  {
   /* store file position and file name */
   ustr[user].file_posn += num_chars;
   ustr[user].line_count = line_pos;
   strcpy(ustr[user].page_file,filename);
   write_str_nr(user,CONF_PROMPT);
	telnet_write_eor(user);
   noprompt=1;
  }
  
SKIP:
  FCLOSE(fp);
  return retval;
}

